//
//  ECViewController.m
//  echo
//
//  Created by Lane on 2/6/13.
//  Copyright (c) 2013 Lane. All rights reserved.
//

#import <FacebookSDK/FacebookSDK.h>
#import "ECViewController.h"
#import "ECAppDelegate.h"

@interface ECViewController ()

@end

@implementation ECViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(sessionStateChanged:) name:SessionStateChangedNotification object:nil];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    if (FBSession.activeSession.isOpen)
    {
        // Do stuff.
    }
    else if (FBSession.activeSession.state == FBSessionStateCreatedTokenLoaded)
    {
        ECAppDelegate *appDelegate = (ECAppDelegate *)[[UIApplication sharedApplication] delegate];
        [appDelegate openSessionWithLoginUI:NO];
    }
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    if (FBSession.activeSession.isOpen
        || FBSession.activeSession.state == FBSessionStateCreatedTokenLoaded
        || FBSession.activeSession.state == FBSessionStateCreatedOpening)
    {
        // Nothing to do.
    }
    else
    {
        NSLog(@"viewDidAppear -> View");
        [self performSegueWithIdentifier:@"LoginSegue" sender:self];
    }
}

- (void)sessionStateChanged:(NSNotification*)notification
{
    if (FBSession.activeSession.isOpen)
    {
        // nothing
    }
    else
    {
        NSLog(@"sessionStateChanged -> View");
        [self performSegueWithIdentifier:@"LoginSegue" sender:self];
    }
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
